=== debian/changelog ===
ocaml (4.08.1-8) unstable; urgency=medium

  * read_main_debug_info: do not die in -custom executables

 -- Stéphane Glondu <glondu@debian.org>  Thu, 30 Jan 2020 13:11:32 +0100

ocaml (4.08.1-7) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Install stdlib-shims compatibility package

  [ Andy Li ]
  * Install uchar compatibility package

 -- Stéphane Glondu <glondu@debian.org>  Tue, 14 Jan 2020 13:36:36 +0100

ocaml (4.08.1-6) unstable; urgency=medium

  * Fix generation of ocaml-man (Closes: #947197)
  * Add Rules-Requires-Root: no
  * Provide libseq-ocaml{,-dev}

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Dec 2019 10:28:39 +0100

ocaml (4.08.1-5) unstable; urgency=medium

  * ocaml-nox: add Breaks+Replaces ocaml-compiler-libs (Closes: #945495)
  * Bump Standards-Version to 4.4.1

 -- Stéphane Glondu <glondu@debian.org>  Mon, 02 Dec 2019 13:04:37 +0100

ocaml (4.08.1-4) unstable; urgency=medium

  * ocaml-base-nox Breaks/Replaces also ocaml-nox (Closes: #944126)
  * Install seq compatibility package

 -- Stéphane Glondu <glondu@debian.org>  Fri, 08 Nov 2019 11:43:37 +0100

ocaml (4.08.1-3) unstable; urgency=medium

  * Do no longer install ocaml-native-compilers.conf (should fix FTBFS of
    many reverse dependencies)
  * Add relationship for ocaml-nox overwriting ocaml-base-nox (Closes:
    #944126)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 06 Nov 2019 11:12:49 +0100

ocaml (4.08.1-2) unstable; urgency=medium

  * Upload to unstable
  * Disable failing tests on hurd

 -- Stéphane Glondu <glondu@debian.org>  Mon, 04 Nov 2019 13:43:40 +0100

ocaml (4.08.1-1) experimental; urgency=medium

  * New upstream release
  * Statically link -lbfd to avoid a tight dependency with libbinutils
    (Closes: #940579)
  * Put VERSION in ocaml-base-nox
  * Add Breaks/Replaces: ocaml-base to ocaml-base-nox (Closes: #933792)
  * Disable testpreempt test on kfreebsd for now
  * Add back Debian-specific -custom behaviour

 -- Stéphane Glondu <glondu@debian.org>  Mon, 30 Sep 2019 16:40:45 +0200

ocaml (4.08.0-3) experimental; urgency=medium

  * Disable native compiler on powerpc and x32
  * Tune testpreempt test to make it work on kfreebsd

 -- Stéphane Glondu <glondu@debian.org>  Tue, 30 Jul 2019 13:27:15 +0200

ocaml (4.08.0-2) experimental; urgency=medium

  * Build with BUILD_PATH_PREFIX_MAP set, to improve reproducibility
  * Use CCLINKFLAGS for linking all executables and shared libraries, to
    pass hardening flags
  * Properly disable almabench test on slow architectures (should fix
    FTBFS on them)
  * Check for definition of AT_SECURE before using it (should fix FTBFS on
    kfreebsd-*)
  * Add x32 to native architecture (should fix FTBFS)
  * Add support for Debian's armhf in configure.ac (should fix FTBFS)
  * Add more Lintian overrides
  * Fix spelling errors reported by Lintian
  * Bump Standards-Version to 4.4.0
  * Remove Samuel from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Wed, 24 Jul 2019 10:53:51 +0200

ocaml (4.08.0-1) experimental; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release
    - many Debian-specific patches have been dropped
    - drop ocaml-mode binary package
    - add ocaml-man binary package
    - update debian/copyright
  * Bump debhelper compat to 12

  [ Nicolas Boulenguez ]
  * Fix broken doc symlinks (Closes: #877267)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Jul 2019 14:19:49 +0200

ocaml (4.05.0-12) unstable; urgency=medium

  * Provide libnum-ocaml{,-dev}

 -- Stéphane Glondu <glondu@debian.org>  Tue, 06 Aug 2019 09:27:23 +0200
