=== debian/control ===
Source: ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Mehdi Dogguy <mehdi@debian.org>,
 Ximin Luo <infinity0@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 pkg-config,
 binutils-dev,
 libiberty-dev,
 libncurses5-dev,
 libx11-dev,
 zlib1g-dev,
 dh-ocaml (>= 1.0.0~)
Standards-Version: 4.4.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml
Homepage: https://ocaml.org/

# This needs to stay at the top - we symlink docs to the copy in this package,
# and dh_installdocs installs README.Debian etc into the first package listed.
Package: ocaml-base-nox
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 libseq-ocaml,
 libuchar-ocaml,
 libstdlib-shims-ocaml,
 ${ocaml:Provides}
Replaces: ocaml-base (<< 4.08), ocaml-nox (<< 4.08)
Breaks: ocaml-base (<< 4.08), ocaml-nox (<< 4.08)
Description: Runtime system for OCaml bytecode executables (no X)
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains only the runtime system needed to run bytecode
 executables that do not use the graphics library. The 'ocaml' package
 contains the full development suite of Objective Caml.

Package: ocaml-base
Architecture: any
Depends:
 ocaml-base-nox,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Description: Runtime system for OCaml bytecode executables
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains only the runtime system needed to run bytecode
 executables. The 'ocaml' package contains the full development suite of
 Objective Caml.  You may wish to install the 'ocaml-base-nox' package if
 you do not require any graphical capabilities for your runtime.

Package: ocaml-nox
Architecture: any
Depends:
 ocaml-base-nox,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libncurses5-dev,
 ocaml-interp (= ${binary:Version}),
 gcc,
 binutils
Provides:
 libseq-ocaml-dev,
 libuchar-ocaml-dev,
 libstdlib-shims-ocaml-dev,
 ${ocaml:Provides},
 ocaml-best-compilers (= ${binary:Version}),
 ${F:NativeProvides}
Suggests:
 ocaml-doc,
 tuareg-mode
Recommends:
 ocaml-man,
 file
Replaces: ocaml-base-nox (<< 4.08), ocaml-compiler-libs (<< 4.08)
Breaks: ocaml-base-nox (<< 4.08), ocaml-compiler-libs (<< 4.08)
Description: ML implementation with a class-based object system (no X)
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to develop OCaml applications
 that do not require the graphics library.

Package: ocaml
Architecture: any
Depends:
 ocaml-base-nox,
 ${misc:Depends},
 ${ocaml:Depends},
 libx11-dev
Provides:
 ${ocaml:Provides}
Description: ML language implementation with a class-based object system
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to develop OCaml applications,
 including the graphics libraries.

Package: ocaml-source
Architecture: all
Depends: ${misc:Depends}
Provides: ocaml-source-${F:OCamlABI}
Description: Sources for Objective Caml
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the sources needed to build some packages which build
 depend on the OCaml source. Notice that if you want to rebuild OCaml, these
 will not work, consider using the source package instead.

Package: ocaml-interp
Architecture: any
Depends:
 ocaml-compiler-libs (= ${binary:Version}),
 ${ocaml:Depends},
 ${misc:Depends}
Provides:
 ocaml-interp-${F:OCamlABI}
Recommends: ledit | readline-editor
Description: OCaml interactive interpreter and standard libraries
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the files required to run an OCaml shell from the
 command line.

Package: ocaml-compiler-libs
Architecture: any
Depends:
 ${misc:Depends},
 ocaml-nox-${F:OCamlABI}
Provides:
 ocaml-compiler-libs-${F:OCamlABI}
Recommends:
 ocaml-man
Replaces: ocaml-base-nox (<< 4)
Breaks: ocaml-base-nox (<< 4)
Description: OCaml interpreter and standard libraries
 Objective (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains several modules used internally by the OCaml
 compilers.  They are not needed for normal OCaml development, but may
 be helpful in the development of certain applications.

Package: ocaml-man
Architecture: all
Depends:
 ${misc:Depends}
Breaks:
 ocaml (<< 4.08),
 ocaml-nox (<< 4.08),
 ocaml-compiler-libs (<< 4.08)
Replaces:
 ocaml (<< 4.08),
 ocaml-nox (<< 4.08),
 ocaml-compiler-libs (<< 4.08)
Description: OCaml interpreter and standard libraries (lib manpages)
 Objective (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains ocamldoc-generated documentation about libraries
 provided by OCaml.
